<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns:fo = "http://www.w3.org/1999/XSL/Format">
<xsl:output method="xml" indent="yes" omit-xml-declaration="yes" encoding="UTF-8"/>


<xsl:template match="/">
<fo:root>
	<fo:layout-master-set>
	<!-- layout for all pages -->
		<fo:simple-page-master master-name="all"
			page-width="21cm"
			page-height="29.7cm"
			margin-top="1cm"
			margin-bottom="1cm"
			margin-left="1cm"
	    margin-right="1cm"
		>
			<fo:region-body column-count="3" column-gap="5mm"
			margin-bottom="7mm"
			/>
			<fo:region-before extent="5mm"/>
      <fo:region-after extent="7mm"/>
		</fo:simple-page-master>
		<fo:simple-page-master master-name="twocolumn"
			page-width="21cm"
			page-height="29.7cm"
			margin-top="1cm"
			margin-bottom="1cm"
			margin-left="1cm"
	    margin-right="1cm"
		>
			<fo:region-body column-count="2" column-gap="5mm"
			margin-bottom="7mm"
			/>
			<fo:region-before extent="5mm"/>
      <fo:region-after extent="7mm"/>
		</fo:simple-page-master>

		<fo:simple-page-master master-name="cover"
			page-width="21cm"
			page-height="29.7cm"
			margin-top="1cm"
			margin-bottom="1cm"
			margin-left="1cm"
	    margin-right="1cm"
		>
			<fo:region-body column-count="1" column-gap="5mm"
			margin-bottom="7mm"
			/>
			<fo:region-before extent="5mm"/>
      <fo:region-after extent="7cm"/>
		</fo:simple-page-master>

  </fo:layout-master-set>
	

<!--
	<fo:page-sequence master-reference="cover">
			<fo:static-content flow-name="xsl-region-after">
				<fo:block font-size="20pt" font-family="eurostile" text-align="right">
				Compatible with 
				<fo:external-graphic src="./images/logo.jpg"/>				
				</fo:block>
			</fo:static-content>
	<fo:flow flow-name="xsl-region-body">
	<fo:block span="all">
	<xsl:apply-templates select="/charlist/cover"/>
	</fo:block>
	</fo:flow>
	</fo:page-sequence>
-->
	<xsl:for-each select="/charlist/character">
		<xsl:choose>
		<xsl:when test="pageintro">
			<fo:page-sequence master-reference="twocolumn">  
			<fo:static-content flow-name="xsl-region-after">
				<fo:block text-align="center" font-size="6pt" font-family="eurostile"><fo:page-number/></fo:block>
			</fo:static-content>
			<fo:flow flow-name="xsl-region-body">
			<fo:block span="all" font-weight="bold" font-family="eurostile" text-align="justify" font-size="24pt"><xsl:apply-templates select="pageintro/@title"/>								
	    <fo:block font-size="10pt"><fo:leader leader-pattern="rule" 
                   rule-thickness="1pt"
                   leader-length="100%"
                   space-before.optimum="0pt"
                   space-after.optimum="0pt"
                   color="black"/>
			</fo:block>                 
		</fo:block>
			<fo:block font-family="eurostile" text-align="justify" font-size="10pt"><xsl:apply-templates select="pageintro"/></fo:block>
			</fo:flow>
			</fo:page-sequence>
			</xsl:when>
		<xsl:otherwise>
		<fo:page-sequence master-reference="all">  
			<fo:static-content flow-name="xsl-region-after">
				<fo:block text-align="center" font-size="6pt" font-family="eurostile"><fo:page-number/></fo:block>
			</fo:static-content>
			<fo:flow flow-name="xsl-region-body">
		<fo:block span="all">
		<fo:inline font-size="24pt" font-weight="bold"  font-family="eurostile">
		<xsl:value-of select="translate(name,'abcdefghijklmnopqrstuvwxyz','ABCDEFGHIJKLMNOPQRSTUVWXYZ')"/></fo:inline>
		</fo:block>

		<fo:block font-size="10pt" span="all"  font-family="eurostile">
		<fo:table table-layout="fixed" width="100%">
			<fo:table-column column-width="proportional-column-width(1)"/>
			<fo:table-column column-width="proportional-column-width(1)"/>
			<fo:table-column column-width="proportional-column-width(3)"/>
			<fo:table-body>
		<fo:table-row>
		<fo:table-cell>
		<fo:table table-layout="fixed" width="100%">
			<fo:table-column column-width="25mm"/>		
			<fo:table-column column-width="proportional-column-width(1)"/>
			<fo:table-body>
			<fo:table-row keep-with-next="always">
			<fo:table-cell><fo:block font-weight="bold">Intelligence</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="attributes/int"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always" >
			<fo:table-cell><fo:block font-weight="bold">Strength</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="attributes/str"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always">
			<fo:table-cell><fo:block font-weight="bold">Agility</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="attributes/agi"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always">
			<fo:table-cell><fo:block font-weight="bold">Speed</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="attributes/spd"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row>
			<fo:table-cell><fo:block font-weight="bold">Durability</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="attributes/dur"/></fo:block></fo:table-cell>
			</fo:table-row>
			</fo:table-body>
		</fo:table>
		</fo:table-cell>
		<fo:table-cell>
		<fo:table table-layout="fixed" width="100%">
			<fo:table-column column-width="20mm"/>
			<fo:table-column column-width="proportional-column-width(1)"/>		

			<fo:table-body>
			<fo:table-row keep-with-next="always">
			<fo:table-cell  padding-right="5pt"><fo:block text-align="right" font-weight="bold">Health</fo:block></fo:table-cell>
			<fo:table-cell  >
			<fo:block padding-right="5pt" text-align="center"><xsl:value-of select="attributes/dur"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always" >
			<fo:table-cell padding-top="10pt" padding-right="5pt"><fo:block text-align="right" font-weight="bold">Energy</fo:block></fo:table-cell>
			<fo:table-cell padding-top="10pt">
			<fo:block padding-right="5pt" text-align="center" ><xsl:value-of select="attributes/ene"/></fo:block></fo:table-cell>
			</fo:table-row>

			<xsl:if test="attributes/info">
			<fo:table-row>
			<fo:table-cell number-columns-spanned="2">
			<fo:block><xsl:value-of select="attributes/info"/>
			</fo:block>
			</fo:table-cell>
			</fo:table-row>
			</xsl:if>

			</fo:table-body>
		</fo:table>
		</fo:table-cell>

		<fo:table-cell>		
		<fo:table table-layout="fixed" width="100%">
			<fo:table-column column-width="25mm"/>		
			<fo:table-column column-width="proportional-column-width(1)"/>
			<fo:table-body>

			<xsl:choose>
			<xsl:when test="alien">
			<fo:table-row keep-with-next="always">
			<fo:table-cell><fo:block font-weight="bold">Appearance</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="appearance"/></fo:block></fo:table-cell>
			</fo:table-row>			

			</xsl:when>
			<xsl:otherwise>
			<fo:table-row keep-with-next="always" >
			<fo:table-cell><fo:block font-weight="bold">Realname</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="realname"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always" >
			<fo:table-cell><fo:block font-weight="bold">Species</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="species"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always">
			<fo:table-cell><fo:block font-weight="bold">Occupation</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="occupation"/></fo:block></fo:table-cell>
			</fo:table-row>
			<fo:table-row keep-with-next="always">
			<fo:table-cell><fo:block font-weight="bold">Appearance</fo:block></fo:table-cell>
			<fo:table-cell><fo:block><xsl:value-of select="appearance"/></fo:block></fo:table-cell>
			</fo:table-row>
			</xsl:otherwise>
			</xsl:choose>
			<xsl:if test="author">
				<fo:table-row>
				<fo:table-cell padding-top="5mm" number-columns-spanned="2"><fo:block font-weight="bold">created by <xsl:value-of select="author"/></fo:block></fo:table-cell>
				</fo:table-row>
			</xsl:if>

			</fo:table-body>
		</fo:table>
		</fo:table-cell>
		</fo:table-row>
		</fo:table-body>
		</fo:table>
		</fo:block>
      <fo:block span="all">
	    <fo:leader leader-pattern="rule" 
                   rule-thickness="1pt"
                   leader-length="100%"
                   space-before.optimum="0pt"
                   space-after.optimum="0pt"
                   color="black"/>
	  </fo:block>

		<fo:block font-size="8pt" text-align="justify"  font-family="eurostile">
			<fo:block font-size="12pt" font-weight="bold"  font-family="eurostile">ACTIONS</fo:block>

				<fo:table table-layout="fixed" width="100%">
					<fo:table-column column-width="5pt"/>
					<fo:table-column column-width="proportional-column-width(1)"/>
					<fo:table-body>
				<xsl:for-each select="actions/action">
						<fo:table-row>
							<fo:table-cell number-columns-spanned="2" padding-before="5pt">
								<fo:block font-weight="bold" font-size="10pt" font-family="eurostile" >
									<xsl:value-of select="@name"/>:<xsl:value-of select="' '"/><xsl:value-of select="@an"/>
								</fo:block>
								</fo:table-cell>
						</fo:table-row>

								<xsl:if test="bonus">
								<fo:table-row keep-with-previous="always">
								<fo:table-cell number-columns-spanned="2">
								<fo:block  font-size="8pt"  font-family="eurostile" font-style="italic">
								(<xsl:value-of select="bonus"/>)
								</fo:block>
								</fo:table-cell>
								</fo:table-row>
								</xsl:if>								
								<xsl:for-each select="specials/spec">
									<fo:table-row keep-with-previous="always">

									<fo:table-cell>
										<fo:block font-family="Helvetica" font-size="8pt">&#x2022;</fo:block>
									</fo:table-cell>

									<fo:table-cell>
										<fo:block>
											<xsl:apply-templates select="."/>
										</fo:block>
									</fo:table-cell>
									</fo:table-row>
							</xsl:for-each>
			</xsl:for-each>
						</fo:table-body>
						</fo:table>
			</fo:block> 
			
    <fo:block span="all">
	  <fo:leader leader-pattern="rule"
    	rule-thickness="1pt"
      leader-length="100%"
      space-before.optimum="0pt"
      space-after.optimum="0pt"
      color="black"/>
	  </fo:block>
		<fo:block font-size="8pt" text-align="justify"  font-family="eurostile">
			<fo:block font-size="12pt" font-weight="bold" font-family="eurostile">MODIFIERS</fo:block>	
			<fo:table table-layout="fixed" width="100%">
					<fo:table-column column-width="5pt"/>					
					<fo:table-column column-width="proportional-column-width(1)"/>
					<fo:table-body>
								<xsl:for-each select="modifiers/mod">
									<fo:table-row>
									<fo:table-cell><fo:block font-family="Helvetica" font-size="8pt" >&#x2022;</fo:block></fo:table-cell>
									<fo:table-cell>
										<fo:block>
											<xsl:apply-templates select="."/>
										</fo:block>
									</fo:table-cell>
									</fo:table-row>
							</xsl:for-each>
						</fo:table-body>
						</fo:table>
	  </fo:block>

    <fo:block span="all">
	  <fo:leader leader-pattern="rule"
    	rule-thickness="1pt"
      leader-length="100%"
      space-before.optimum="0pt"
      space-after.optimum="0pt"
      color="black"/>
	  </fo:block>
		<fo:block font-size="8pt" text-align="justify" font-family="eurostile">
			<fo:block font-size="12pt" font-weight="bold" font-family="eurostile">EQUIPMENT</fo:block>	
			<fo:table table-layout="fixed" width="100%">
					<fo:table-column column-width="5pt"/>					
					<fo:table-column column-width="proportional-column-width(1)"/>
					<fo:table-body>
								<xsl:for-each select="equipment/equ">
									<fo:table-row>
									<fo:table-cell><fo:block  font-family="Helvetica" font-size="8pt">&#x2022;</fo:block></fo:table-cell>
									<fo:table-cell>
										<fo:block>
											<xsl:apply-templates select="."/>
										</fo:block>
									</fo:table-cell>
									</fo:table-row>
							</xsl:for-each>
						</fo:table-body>
						</fo:table>
	  </fo:block>


    <fo:block span="all">
	  <fo:leader leader-pattern="rule"
    	rule-thickness="1pt"
      leader-length="100%"
      space-before.optimum="0pt"
      space-after.optimum="0pt"
      color="black"/>
	  </fo:block>
		<fo:block font-size="8pt" text-align="justify" font-family="eurostile">
			<fo:block font-size="12pt" font-weight="bold" font-family="eurostile" >CHALLENGES</fo:block>	
			<fo:table table-layout="fixed" width="100%">
					<fo:table-column column-width="5pt"/>					
					<fo:table-column column-width="proportional-column-width(1)"/>
					<fo:table-body>
								<xsl:for-each select="challenges/cha">
									<fo:table-row>
									<fo:table-cell><fo:block  font-family="Helvetica" font-size="8pt">&#x2022;</fo:block></fo:table-cell>
									<fo:table-cell>
										<fo:block>
											<xsl:apply-templates select="."/>
										</fo:block>
									</fo:table-cell>
									</fo:table-row>
							</xsl:for-each>
						</fo:table-body>
						</fo:table>
	  </fo:block>

    <fo:block span="all">
	  <fo:leader leader-pattern="rule" 
    	rule-thickness="1pt"
      leader-length="100%"
      space-before.optimum="0pt"
      space-after.optimum="0pt"
      color="black"/>
	  </fo:block>
		<fo:block font-size="8pt" text-align="justify"  font-family="eurostile">
			<fo:block font-size="12pt" font-weight="bold"  font-family="eurostile">BACKGROUND</fo:block>
			<xsl:apply-templates select="background"/>
	  </fo:block>

		</fo:flow>
		</fo:page-sequence>
		</xsl:otherwise>
		</xsl:choose>
		</xsl:for-each>
</fo:root>

</xsl:template>

<xsl:template match="b">
	<fo:inline font-weight="bold"><xsl:apply-templates/></fo:inline>
</xsl:template>

<xsl:template match="i">
	<fo:inline font-style="italic"><xsl:apply-templates/></fo:inline>
</xsl:template>

<xsl:template match="br">
<fo:block/>
</xsl:template>

<xsl:template match="p">
	<fo:block keep-together="auto" padding-top="5pt" padding-bottom="5pt"><xsl:apply-templates /></fo:block>
</xsl:template>

<xsl:template match="ul">
<fo:block><xsl:apply-templates/></fo:block>
</xsl:template>

<xsl:template match="ul/li">
<fo:block padding-left="2pt"  font-family="Helvetica" font-size="8pt">&#x2022; <xsl:apply-templates/></fo:block>
</xsl:template>

<xsl:template match="img">
	<fo:external-graphic src="{@src}"/>
</xsl:template>

<xsl:template match="center">
	<fo:block text-align="center">
	<xsl:apply-templates/>
	</fo:block>

</xsl:template>
<xsl:template match="title">
	<fo:block font-family="eurostile" font-size="72pt" font-weight="bold">
	<xsl:apply-templates/>
	</fo:block>
</xsl:template>

<xsl:template match="head">
	<fo:block font-family="eurostile" font-size="16pt" font-weight="bold">
	<xsl:apply-templates/>
	</fo:block>
</xsl:template>

<xsl:template match="h0">
	<fo:block span="all" font-family="eurostile" font-size="24pt" font-weight="bold">
	<xsl:apply-templates/>
	</fo:block>
</xsl:template>


<xsl:template match="border">
	<fo:block font-family="eurostile" font-size="10pt"  
	border-style="solid" border-width="1pt"
	padding-top="3pt" padding-left="3pt" padding-right="3pt"
	padding-bottom="3pt"
	>
	<xsl:apply-templates/>
	</fo:block>
</xsl:template>

<xsl:template match="span">
	<fo:block span="all">
	<xsl:apply-templates/>
	</fo:block>
</xsl:template>

<xsl:template match="homegrown">
<xsl:for-each select="/charlist/character/author">
<fo:block><xsl:value-of select="."/></fo:block>
</xsl:for-each>
</xsl:template>

<xsl:template match="space">
<fo:block space-after="{@height}"><xsl:value-of select="' '"/></fo:block>

</xsl:template>

</xsl:stylesheet>