package net.sachau.murpg.data.action;
import java.io.*;

import net.sachau.murpg.data.bonus.BonusList;
import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.option.OptionList;
import net.sachau.murpg.data.GeneralData;

public class Action extends ActionBase implements Cloneable,Serializable {

	public BonusList bonus;
	public OptionList option;
	public SpecList spec;

	public Action() {
		super();
		option = new OptionList();
		bonus = new BonusList();
		spec = new SpecList();
		cost = new Cost();
		spec.clear();
	}

	public void dump() {
		super.dump();
		this.option.dump();
		this.bonus.dump();

	}

	public String toString() {
		Character c =
			(Character) GeneralData.character.get(GeneralData.charindex);
		String stringPA = "";
		String tname=this.name;
		if (this.hasPA && c.isPA) {
			stringPA = "PA ";
			if (this.pa_name.length()>0) {
				tname=this.pa_name;
			}

		}
		
		if (this.flat>0) {
			return stringPA+tname;
		}
		if (this.note.length()>0) {
			return stringPA+tname + ": " + this.AN+"/"+this.note;
		}
		return stringPA+tname + ": " + this.AN;
		
	}

	public String toString1() {
		Character c =
			(Character) GeneralData.character.get(GeneralData.charindex);
		String stringPA = "";
		String tname=this.name;
		
		if (this.shortName.length()>0) {
			return tname+" ("+this.shortName+")";
		}
		return tname;
		
	}

	public Object clone() {

		Action cloned = (Action) super.clone();
		return cloned;
	}

}
