package net.sachau.murpg.data.action;

import java.util.ArrayList;
import net.sachau.murpg.data.bonus.Bonus;
import net.sachau.murpg.data.option.Option;
import net.sachau.murpg.data.*;
public class ActionList extends ArrayList {

	public void addAction(Action a) {
		for (int i = 0; i < this.size(); i++) {
			Action t = (Action) this.get(i);
			if (a.name.equals(t.name)) {
				this.set(i, a);
				return;
			}
		}
		this.add(a);
	}

	public void removeAction(int key) {
		for (int i = 0; i < this.size(); i++) {
			Action t = (Action) this.get(i);
			if (t.key == key) {
				this.remove(i);
				return;
			}
		}
	}

	public void addAction(int i) {
		Action a = new Action();
		a = (Action) GeneralData.actions.get(i);
		this.add(a);

	}

	public void dump() {
		for (int i = 0; i < this.size(); i++) {
			Action t = (Action) this.get(i);
			t.dump();
		}

	}

	public String toXML() {
		String s = "";
		for (int i = 0; i < this.size(); i++) {
			Action a = (Action) this.get(i);
			if (a.note.length()==0) {
				s += "<action name=\"" + a.name + "\" an=\"" + a.AN + "\">\n";
			} else {
				s += "<action name=\"" + a.name + "\" an=\"" + a.AN + "/"+a.note+ "\">\n";
			}

			
			int b = a.bonus.size();
			if (b > 0) {
				s += "<bonus>";
				for (int j = 0; j < b; j++) {
					Bonus bo = (Bonus) a.bonus.get(j);
					s += bo.name;
					if (j < b - 1) {
						s += ", ";
					}
				}
				s += "</bonus>\n";
			}
			s += "<specials>\n";
			int o = a.option.size();
			if (o > 0) {

				for (int j = 0; j < o; j++) {
					Option op = (Option) a.option.get(j);
					s += "<spec>" + op.name + "</spec>\n";
				}

			}
			o = a.spec.size();
			if (o > 0) {
				for (int j = 0; j < o; j++) {
					Specialization op = (Specialization) a.spec.get(j);
					s += "<spec>" + op.name + "</spec>\n";
				}
			}
			s += "</specials>\n";
			s += "</action>\n";
		}

		return s;
	}

	public static String toBasicHtmlJoin(ActionList n, ActionList p) {

		String s = "";
		for (int i = 0; i < n.size(); i++) {
			Action a = (Action) n.get(i);
			System.out.println(">>>" + a.key + " " + n.size() + " " + p.size());
			boolean found = false;
			for (int j = 0; j < p.size(); j++) {
				Action b = (Action) p.get(j);
				System.out.println(">>>" + a.key + " " + b.key);
				if (a.key == b.key) {
					s += "Action: " + a.name + " " + a.AN + " / " + b.AN + "\n";
					found = true;
				}
			}
			if (!found) {
				s += "Action: " + a.name + " " + a.AN + "\n";
			}

		}
		return s;
	}

	public String toBasicHtml() {
		String s = "";
		for (int i = 0; i < this.size(); i++) {
			Action a = (Action) this.get(i);

			s += "* " + a.name + " " + a.AN + "\n";
			int b = a.bonus.size();
			if (b > 0) {
				s += "(";
				for (int j = 0; j < b; j++) {
					Bonus bo = (Bonus) a.bonus.get(j);
					s += bo.name;
					if (j < b - 1) {
						s += ", ";
					}
				}
				s += ")\n";
			}
			int o = a.option.size();
			if (o > 0) {

				for (int j = 0; j < o; j++) {
					Option op = (Option) a.option.get(j);
					s += "- " + op.name + "\n";
				}

			}

			o = a.spec.size();
			if (o > 0) {

				for (int j = 0; j < o; j++) {
					Specialization op = (Specialization) a.spec.get(j);
					s += "- " + op.name + "\n";
				}

			}

		}

		return s;
	}

}
