package net.sachau.murpg.data.attribute;

import java.util.ArrayList;


import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.option.Option;
import net.sachau.murpg.data.GeneralData;
public class AttributeList extends ArrayList {

	public AttributeList() {
		super();
	}

	public void addAttribute(Attribute a) {
		/*	for (int i = 0; i < this.size(); i++) {
				Attribute t=(Attribute)this.get(i);
				if (a.name.equals(t.name)) {
					this.set(i,a);
					return;
				}
			}
		*/
		this.add((Attribute) a);
	}

	public void dump() {
		for (int i = 0; i < this.size(); i++) {
			Attribute t = (Attribute) this.get(i);
			t.dump();
		}

	}

	public String toXML() {
		String s = "";
		int health = 0;
		int intelligence = 0;
		int energy = 0;
		boolean intBased = false;
		String opt = "";
		for (int i = 0; i < this.size(); i++) {
			Attribute a = (Attribute) this.get(i);
			opt = "";
			for (int j = 0; j < a.option.size(); j++) {
				Option o = (Option) a.option.get(j);
				opt += o.shortName;
				if (o.shortName.toLowerCase().equals("(i)")) {
					intBased = true;
					intelligence = a.AN;
				}
			}
			s += "<"
				+ a.var.toLowerCase()
				+ ">"
				+ a.AN
				+ " "
				+ opt
				+ "</"
				+ a.var.toLowerCase()
				+ ">\n";
			if (a.var.toLowerCase().equals(("dur"))) {
				health = a.AN;
			}
		}
		energy = 3 * health;
		if (intBased) {
			energy = 2 * intelligence;
		}
		s += "<ene>" + energy + "</ene>\n";
		return s;
	}

	public String toBasicHtml() {
		String s = "";
		int health = 0;
		int healthPA=  0;
		int intelligence = 0;
		
		int energy = 0;
		boolean intBased = false;
		String opt = "";
		for (int i = 0; i < this.size(); i++) {
			Attribute a = (Attribute) this.get(i);
			opt = "";
			for (int j = 0; j < a.option.size(); j++) {
				Option o = (Option) a.option.get(j);
				opt += o.shortName;
				if (o.shortName.toLowerCase().equals("(i)")) {
					intBased = true;
					intelligence = a.AN;
				}
			}
			s += a.name + ": " +a.AN + " " + opt + "\n";
			if (a.var.toLowerCase().equals(("dur"))) {
				health = a.AN;
			}
		}
		energy = 3 * health;
		if (intBased) {
			energy = 2 * intelligence;
		}
		s += "Energy: "+energy+"\n";
		return s;
	}

	public Cost calcCost() {

		Cost cost = new Cost(0, 0);

		for (int i = 0; i < this.size(); i++) {
			Cost costf = new Cost(0, 0);
			Cost cAN = new Cost();
			int AN;
			double multi = 1;
			Attribute a = (Attribute) this.get(i);
			AN = a.AN;
			multi = a.multi;
			if (a.option.size() > 0) {
				for (int j = 0; j < a.option.size(); j++) {
					Option o = (Option) a.option.get(j);
					if (o.flat == 1) {
						costf.set(costf.w + o.cost.w, costf.r + o.cost.r);
					} else {
						AN += o.AN;
					}
					if (o.multi > 1) {
						multi *= o.multi;
					}
				}
			}

			cAN = GeneralData.costtable.getCost(AN);

			cost.set(
				cost.w + (int) ((cAN.w + costf.w) * multi),
				cost.r + (int) ((cAN.r + costf.r) * multi));

		}
		return cost;
	}

}
