package net.sachau.murpg.data.character;

import java.io.*;

import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.data.action.*;
import net.sachau.murpg.data.attribute.*;
import net.sachau.murpg.data.cost.*;
import net.sachau.murpg.data.equipment.EquipmentList;

import net.sachau.murpg.data.modifier.*;
import net.sachau.murpg.data.physical.PhysicalDataList;
public class Character implements Serializable {
	public PhysicalDataList physical;
	public String background;
	public String description;
	public AttributeList attributes;
	public AttributeList attributesPA;
	public ActionList actions;
	public ActionList actionsPA;
	public ModifierList modifiers;
	public ModifierList modifiersPA;
	public ModifierList challenges;
	public EquipmentList equipment;
	public boolean isRobot;
	public boolean isPA;

	public Character() {
		background = "";
		description = "";

		attributes = new AttributeList();
		attributesPA = new AttributeList();
		actions = new ActionList();
		actionsPA = new ActionList();
		modifiers = new ModifierList();
		modifiersPA = new ModifierList();
		challenges = new ModifierList();
		physical = new PhysicalDataList();
		equipment = new EquipmentList();
	}

	public String toBasicHtml() {

		String s = "Description\n";

		s += this.physical.toBasicHtml();

		s += "\n\nAttributes:\n";
		s += this.attributes.toBasicHtml();

		if (this.isPA) {

			s += "\n\nPA Attributes:\n";
			s += this.attributesPA.toBasicHtml();
		}
		s += "\n\nActions:\n";
		
		
		if (this.isPA) {
			
			s+=ActionList.toBasicHtmlJoin(this.actions,this.actionsPA);

		} else {
			//s+=this.actions.toBasicHtml();
		}
		s += "\n\nModifiers:\n";
		s += this.modifiers.toBasicHtml();

		if (this.isPA) {

			s += "\n\nPA Modifiers:\n";
			s += this.modifiersPA.toBasicHtml();
		}
		s += "\n\n" + this.isPA;
		return s;
	}

	public String toXML() {

		String s = "<charlist><character>\n";

		s += this.physical.toXML();

		s += "<attributes>\n";
		s += this.attributes.toXML();
		s += "</attributes>\n";

		s += "<actions>\n";
		s += this.actions.toXML();
		s += "</actions>\n";
		s += "<modifiers>\n";
		s += this.modifiers.toXML();
		s += "</modifiers>\n";

		s += "<challenges>\n";
		s += this.challenges.challengeToXML();
		s += "</challenges>\n";

		Cost c = this.attributes.calcCost();

		s += "</character></charlist>\n";

		

		return s;
	}

	public static Character getCurrentCharacter() {

		return (Character) GeneralData.character.get(GeneralData.charindex);

	}

	public static boolean isCurrentPA() {

		Character c = getCurrentCharacter();
		return c.isPA;
	}
}
