package net.sachau.murpg.data.modifier;

import java.util.ArrayList;
import net.sachau.murpg.data.bonus.*;
import net.sachau.murpg.data.option.Option;
public class ModifierList extends ArrayList {

	public ModifierList() {
		super();
	}

	public void addModifier(Modifier b) {
		for (int i = 0; i < this.size(); i++) {
			Bonus t = (Bonus) this.get(i);
			if (b.name.equals(t.name)) {
				this.set(i, b);
				return;
			}
		}
		this.add(b);
	}

	public void removeModifier(int key) {
		for (int i = 0; i < this.size(); i++) {
			Modifier t = (Modifier) this.get(i);
			if (t.key == key) {
				this.remove(i);
				return;
			}
		}

	}
	public void removeModifier(Modifier b) {
		this.remove(b);
	}

	public String toXML() {
		String s = "";
		String opts = "";
		for (int i = 0; i < this.size(); i++) {
			Modifier a = (Modifier) this.get(i);

			int o = a.option.size();
			if (o > 0) {
				opts += "(";
				for (int j = 0; j < o; j++) {
					Option op = (Option) a.option.get(j);
					opts += op.name;
					if (j < o - 1) {
						opts += ", ";
					}

				}
				opts += ")";
			}
			s += "<mod>"
				+ (a.noAN == 1 ? "" : "+" + a.AN + " ")
				+ a.name
				+ (opts.length() > 0 ? " " + opts : "")
				+ "</mod>\n";

		}

		return s;
	}

	public String challengeToXML() {
		String s = "";

		for (int i = 0; i < this.size(); i++) {
			Modifier a = (Modifier) this.get(i);
			s += "<cha>" + a.name + " (+" + a.cost.w + ")</cha>\n";
		}

		return s;
	}

	public String toBasicHtml() {
		String s = "";
		for (int i = 0; i < this.size(); i++) {
			Modifier a = (Modifier) this.get(i);

			s += "* " + a.name + " " + a.AN;
			int o = a.option.size();
			if (o > 0) {
				s+=" (";
				for (int j = 0; j < o; j++) {
					Option op = (Option) a.option.get(j);
					s += op.name;
					if (j<o-1) {
						s+=", ";
					}
				}
				s+=")\n";

			}
			else {
				s+="\n";
			}

		}

		return s;
	}

}
