package net.sachau.murpg.gui;

//import java.awt.*;
import java.io.*;
import java.awt.event.*;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JMenuBar;
//import javax.swing.KeyStroke;
//import javax.swing.ImageIcon;
import javax.swing.*;





import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.character.CharacterList;
import net.sachau.murpg.xml.Build;

public class Menu extends JMenuBar implements ActionListener, ItemListener {

	JFileChooser filec;

	public Menu() {
		super();

		filec = new JFileChooser();
		JMenu menu, submenu;
		JMenuItem menuItem;

		menu = new JMenu("File");
		add(menu);
		menuItem = new JMenuItem("Export as PDF...");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem = new JMenuItem("Export as XML...");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem = new JMenuItem("Save ...");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem = new JMenuItem("Load ...");
		
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menu = new JMenu("Character");
		add(menu);
		menuItem = new JMenuItem("Add Character");
		menuItem.addActionListener(this);
		menu.add(menuItem);
		menuItem = new JMenuItem("Add PA Character");
		menuItem.setEnabled(false);
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menuItem = new JMenuItem("Remove Selected");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menu = new JMenu("View");
		add(menu);
		menuItem = new JMenuItem("Preview");
		menuItem.addActionListener(this);
		menu.add(menuItem);

		menu = new JMenu("?");
		add(menu);
		menuItem = new JMenuItem("Version");
		menuItem.addActionListener(this);
		menu.add(menuItem);

	}

	public void actionPerformed(ActionEvent e) {

		JMenuItem source = (JMenuItem) (e.getSource());
		String s = source.getText();

		if (s.equals(("Export as PDF..."))) {
			filec.setFileFilter(new PDFFilter());
			filec.setDialogTitle("Export Character as PDF");
			for (int i = 0; i < GeneralData.character.size(); i++) {
				Character c = (Character) GeneralData.character.get(i);
				
				int returnVal = filec.showSaveDialog(Menu.this);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = filec.getSelectedFile();
					
					Build.createPDF(c.toXML(),file);
				}
			}
		}
		if (s.equals(("Export as XML..."))) {
			filec.setFileFilter(new PDFFilter());
			filec.setDialogTitle("Export Character as XML");
			for (int i = 0; i < GeneralData.character.size(); i++) {
				Character c = (Character) GeneralData.character.get(i);
				
				int returnVal = filec.showSaveDialog(Menu.this);
				if (returnVal == JFileChooser.APPROVE_OPTION) {
					File file = filec.getSelectedFile();
					Build.createPDF(c.toXML(),file);
				}
			}
		}
		
		
		if (s.equals(("Save ..."))) {
			

			int returnVal = filec.showSaveDialog(Menu.this);
			if (returnVal == JFileChooser.APPROVE_OPTION) {
				try {
					File file = filec.getSelectedFile();
			
					System.out.println(file.getAbsolutePath());
					ObjectOutputStream out =
						new ObjectOutputStream(
							new FileOutputStream(file.getAbsolutePath()));
					out.writeObject((CharacterList) GeneralData.character);
				} catch (Exception ex) {
					System.out.println(ex);
				}
			}

		}

		if (s.equals(("Load ..."))) {

			try {
				
				filec.setDialogTitle("Save Characters as...");
				
					int returnVal = filec.showOpenDialog(Menu.this);
					
					if (returnVal == JFileChooser.APPROVE_OPTION) {
						File file = filec.getSelectedFile();

						CharacterList loaddata = new CharacterList();
						ObjectInputStream in =
						new ObjectInputStream(new FileInputStream(file));
						GeneralData.character.clear();
						GeneralData.charactertab.removeAll();
						loaddata = (CharacterList) in.readObject();

						for (int j = 0; j < loaddata.size(); j++) {
							Character c = (Character) loaddata.get(j);
							GeneralData.character.add(c);
							int type = 0;
							if (c.isPA) {
								type = 1;
							}
							MurpgPanel mtree = new MurpgPanel(j, type);
							GeneralData.charactertab.add("Layer " + j, mtree);

						}
						GeneralData.charactertab.renameTabs();
					}
			} catch (Exception ex) {
				System.out.println(ex);
			}

		}

		if (s.equals(("Add Character"))) {
			GeneralData.charactertab.addCharacter(0);
		}

		if (s.equals(("Add PA Character"))) {

			GeneralData.charactertab.addCharacter(1);
		}

		if (s.equals(("Remove Selected"))) {
			if (GeneralData.charactertab.getSelectedIndex() >= 0) {

				GeneralData.character.remove(
					GeneralData.charactertab.getSelectedIndex());

				GeneralData.charactertab.remove(
					GeneralData.charactertab.getSelectedIndex());
				GeneralData.charactertab.renameTabs();
			}

		}

		if (s.equals("Preview")) {
			if (GeneralData.characterpreview.isVisible()) {
				GeneralData.characterpreview.hidePreview();
			} else {
				GeneralData.characterpreview.showPreview();
			}

		}

		if (s.equals("Version")) {
			VersionFrame vf = new VersionFrame();

		}

	}
	public void itemStateChanged(ItemEvent e) {
		JMenuItem source = (JMenuItem) (e.getSource());
		String s =
			"Item event detected."
				+ "    Event source: "
				+ source.getText()
				+ " (an instance of "
				+ ")"
				+ "    New state: "
				+ ((e.getStateChange() == ItemEvent.SELECTED)
					? "selected"
					: "unselected");
	}

}
