package net.sachau.murpg.gui.action;

import javax.swing.*;

import net.sachau.murpg.data.action.Action;
import net.sachau.murpg.data.GeneralData;



import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;
import java.awt.*;

public class ActionCostFrame
	extends JFrame
	implements ActionListener, WindowListener {

	Action action;
	ActionNumberPanel anp;
	JPanel content;
	JSpinner costW;
	JSpinner costR;
	JCheckBox flat;
	private static String APPLY_COMMAND = "apply";
	private static String CANCEL_COMMAND = "cancel";
	public ActionCostFrame(Action a, ActionNumberPanel t) {

		super("Custom");
		action = a;
		anp=t;
		content = new JPanel();
		addWindowListener(this);

		content.setBorder(BorderFactory.createTitledBorder("Cost for "+a.name));

		GridBagLayout layout = new GridBagLayout();
		content.setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();
		
		costW = new JSpinner(new SpinnerNumberModel(action.cost.w, -99, 99, 1));
		costR = new JSpinner(new SpinnerNumberModel(action.cost.r, -99, 99, 1));

		flat = new JCheckBox();

		if (action.flat == 0) {
			flat.setSelected(false);
		} else {
			flat.setSelected(true);
		}

		JLabel t1 = new JLabel("Cost:");
		JLabel t2 = new JLabel("Flat:");

		JLabel t3 = new JLabel("White");
		JLabel t4 = new JLabel("Red");

		JButton apply = new JButton("Apply");
		apply.setActionCommand(APPLY_COMMAND);
		apply.addActionListener(this);

		JButton cancel = new JButton("Cancel");
		cancel.setActionCommand(CANCEL_COMMAND);
		cancel.addActionListener(this);

		//setBounds(GeneralData.mainframe.getX()+GeneralData.mainframe.getWidth()/2
		//,GeneralData.mainframe.getY()+GeneralData.mainframe.getHeight()/2,300,300);

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 1;
		con.gridy = 0;
		content.add(t3, con);

		con.gridx = 2;
		con.gridy = 0;
		content.add(t4, con);

		con.gridx = 0;
		con.gridy = 1;
		content.add(t1, con);

		con.gridx = 1;
		con.gridy = 1;
		content.add(costW, con);

		con.gridx = 2;
		con.gridy = 1;
		content.add(costR, con);

		con.gridx = 0;
		con.gridy = 2;
		content.add(t2, con);

		con.gridx = 1;
		con.gridy = 2;
		content.add(flat, con);

		con.gridx = 1;
		con.gridy = 3;
		content.add(apply, con);

		con.gridx = 2;
		con.gridy = 3;
		content.add(cancel, con);


		setContentPane(content);

		this.setLocation(
			GeneralData.mainframe.getX() + GeneralData.mainframe.getWidth() / 2,
			GeneralData.mainframe.getY()
				+ GeneralData.mainframe.getHeight() / 2);
		pack();
		setVisible(true);

		GeneralData.mainframe.setEnabled(false);

		action = a;
	}

	public void actionPerformed(ActionEvent e) {

		String command = e.getActionCommand();

		if (APPLY_COMMAND.equals(command)) {
			this.action.cost.w = ((Integer) this.costW.getValue()).intValue();
			this.action.cost.r = ((Integer) this.costR.getValue()).intValue();
			this.action.flat = (this.flat.isSelected()) ? 1 : 0;
			GeneralData.mainframe.setEnabled(true);
			this.anp.updateView();
			
			this.dispose();
		}
		if (CANCEL_COMMAND.equals(command)) {
			this.dispose();
		}
	}

	public void windowActivated(WindowEvent w) {
	}

	public void windowClosed(WindowEvent w) {
		GeneralData.mainframe.setEnabled(true);
	}

	public void windowClosing(WindowEvent w) {
		GeneralData.mainframe.setEnabled(true);
	}

	public void windowDeactivated(WindowEvent w) {
	}

	public void windowDeiconified(WindowEvent w) {
	}

	public void windowIconified(WindowEvent w) {
	}

	public void windowOpened(WindowEvent w) {

	}

	

}
