package net.sachau.murpg.gui.action;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.text.*;

import net.sachau.murpg.data.action.Action;
import net.sachau.murpg.data.GeneralData;

public class ActionNumberPanel extends JPanel implements ActionListener {

	Action action;
	int AN;
	JTextField actionName;
	JTextField actionNote;
	boolean showAN;
	JSpinner anSpinner;
	JSpinner anSpinnerPA;
	JLabel t2, temp;
	JTree list;
	private static String APPLY_COMMAND = "apply";
	private static String COST_COMMAND = "cost";

	boolean isModifier;
	boolean isChallenge;
	GridBagConstraints con;
	public ActionNumberPanel(Action a, JTree l) {
		super();
		list = l;

		action = a;

		setBorder(BorderFactory.createTitledBorder("Action"));
		actionName = new JTextField(action.name, 30);

		anSpinner = new JSpinner(new SpinnerNumberModel(action.AN, 0, 99, 1));
		anSpinnerPA =
			new JSpinner(new SpinnerNumberModel(action.AN_PA, 0, 99, 1));
		actionNote = new JTextField(action.note, 5);
		anSpinner.setValue(new Integer(action.AN));

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		con = new GridBagConstraints();

		JButton applyButton = new JButton("Apply");
		JButton costButton = new JButton("Custom");
		applyButton.setActionCommand(APPLY_COMMAND);
		applyButton.addActionListener(this);
		costButton.setActionCommand(COST_COMMAND);
		costButton.addActionListener(this);

		JLabel t1 = new JLabel("Name:");
		t2 = new JLabel("AN:");
		temp = new JLabel("    ");

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 1;
		con.gridy = 0;
		con.gridwidth = 5;
		add(actionName, con);

		con.gridx = 0;
		con.gridy = 1;
		con.gridwidth = 1;
		if (action.flat == 0) {
			showAN = true;
			add(t2, con);
		}

		con.weightx = 100;
		con.weighty = 0;

		con.gridx = 1;
		con.gridy = 1;
		con.gridwidth = 1;

		if (action.flat == 0) {
			add(anSpinner, con);
		} else {

			add(temp, con);
		}
		

			con.gridx = 2;
			con.gridy = 1;
			add(new JLabel(" Note:"), con);
			con.gridx = 3;
			con.gridy = 1;
			con.weightx = 100;
			con.gridwidth = 1;
			con.anchor = GridBagConstraints.WEST;
			con.fill = GridBagConstraints.HORIZONTAL;
			add(actionNote, con);
		
		con.weightx = 0;
		con.weighty = 0;

		con.gridx = 5;
		con.gridy = 1;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.EAST;
		add(applyButton, con);

		con.gridx = 4;
		con.gridy = 1;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.EAST;
		add(costButton, con);

	}

	public void updateView() {
		this.con.anchor = GridBagConstraints.WEST;
		this.con.weightx = 100;

		this.con.weighty = 0;
		this.con.gridx = 1;
		this.con.gridy = 1;
		this.con.gridwidth = 2;

		if (this.action.flat == 0) {
			if (!this.showAN) {
				this.add(this.anSpinner, this.con);
				this.con.weightx = 0;
				con.gridx = 0;
				con.gridy = 1;
				con.gridwidth = 1;
				this.add(this.t2, this.con);
				this.showAN = true;
			}
		} else {
			if (this.showAN) {
				this.remove(this.anSpinner);
				this.remove(this.t2);
				this.showAN = false;

				this.add(this.temp, con);
			} else {
				this.add(this.anSpinner, this.con);
				this.con.weightx = 0;
				con.gridx = 0;
				con.gridy = 1;
				con.gridwidth = 1;
				this.add(this.t2, this.con);
				this.showAN = true;
			}

		}
		this.updateUI();
	}

	public void actionPerformed(ActionEvent e) {

		this.action.name = this.actionName.getText();
		this.action.note = this.actionNote.getText();

		String command = e.getActionCommand();

		if (APPLY_COMMAND.equals(command)) {

			if (!this.isChallenge) {
				this.action.AN =
					((Integer) this.anSpinner.getValue()).intValue();
			} else {
				this.action.cost.w =
					((Integer) this.anSpinner.getValue()).intValue();
			}

			//this.action.AN=(int)Integer.parseInt(this.actionNumber.getText().trim());
			GeneralData.statusline.setText("xyz");
			GeneralData.statusline.update();
			this.list.updateUI();
		}

		if (COST_COMMAND.equals(command)) {

			ActionCostFrame c = new ActionCostFrame(this.action, this);

		}

	}
	protected MaskFormatter createFormatter(String s) {
		MaskFormatter formatter = null;
		try {
			formatter = new MaskFormatter(s);
		} catch (java.text.ParseException exc) {
			System.err.println("formatter is bad: " + exc.getMessage());
			System.exit(-1);
		}
		return formatter;
	}

}
