package net.sachau.murpg.gui.action;
import javax.swing.*;

import net.sachau.murpg.data.action.SpecList;
import net.sachau.murpg.data.action.Specialization;
import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.GeneralData;


import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class SpecListPanel extends JPanel implements ActionListener {

	SpecList olist;

	JTextField custName;
	JTextField custNameShort;
	JTextField custCostW;
	JTextField custCostR;
	JCheckBox custFlat;
	JList listOwn;
	JTextField input;

	private static String ADD_COMMAND = "add";
	private static String REMOVE_COMMAND = "remove";
	private static String CUSTOM_COMMAND = "custom";
	public SpecListPanel(SpecList ol) {
		super();

		setBorder(BorderFactory.createTitledBorder("Specializations"));
		custName = new JTextField("", 5);
		custNameShort = new JTextField("", 5);
		JTextField custCostW = new JTextField("", 5);
		JTextField custCostR = new JTextField("", 5);
		JCheckBox custFlat = new JCheckBox();
		olist = ol;

		listOwn = new JList(olist.toArray());

		input = new JTextField("", 40);
		listOwn.setVisibleRowCount(5);
		listOwn.setFixedCellWidth(16 * 30);

		JScrollPane listScroller = new JScrollPane(listOwn);

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		JButton addOption = new JButton("Add");
		addOption.setActionCommand(ADD_COMMAND);
		addOption.addActionListener(this);

		JButton removeOption = new JButton("Remove");
		removeOption.setActionCommand(REMOVE_COMMAND);
		removeOption.addActionListener(this);

/*		JButton customOption = new JButton("Change");
		customOption.setActionCommand(CUSTOM_COMMAND);
		customOption.addActionListener(this);
*/
		
		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		
		con.gridx = 0;
		con.gridy = 0;
		con.gridheight = 3;
		con.gridwidth = 7;
		add(listScroller, con);

		con.gridx = 0;
		con.gridy = 4;
		con.gridheight = 1;
		con.gridwidth = 7;
		add(input, con);
		
		con.anchor = GridBagConstraints.EAST;
		con.gridx = 1;
		con.gridy = 5;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(addOption, con);

		con.gridx = 2;
		con.gridy = 5;
		con.gridheight = 1;
		con.gridwidth = 1;
//		add(customOption, con);

		con.gridx = 2;
		con.gridy = 5;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(removeOption, con);

	}

	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		boolean hasChanged = false;

		Character c =
			(Character) GeneralData.character.get(GeneralData.charindex);

		if (ADD_COMMAND.equals(command)) {
			Specialization s=new Specialization();
			s.name=this.input.getText();
			this.olist.add((Specialization) s);
			this.listOwn.setListData(this.olist.toArray());
			this.listOwn.updateUI();
			
			/*			for (int i = 0;
							i < this.listAvail.getSelectedValues().length;
							i++) {
							Option o =
								(Option) ((Option) this.listAvail.getSelectedValues()[i])
									.clone();
							//this.olist.addOption(o);
							hasChanged = true;
						}
			
						if (hasChanged) {
							this.listOwn.setListData(this.olist.toArray());
							this.listAvail.setSelectedIndices(new int[] {
							});
							this.listOwn.setSelectedIndices(new int[] {
							});
							this.listOwn.updateUI();
						}
			*/
			return;
		}

		if (REMOVE_COMMAND.equals(command)) {

			for (int i = 0; i < this.listOwn.getSelectedValues().length; i++) {
				Specialization o =
					(Specialization) ((Specialization) this.listOwn.getSelectedValues()[i]);
				this.olist.remove(o);
				hasChanged = true;
			}
			if (hasChanged) {
				this.listOwn.setListData(this.olist.toArray());
				this.listOwn.setSelectedIndices(new int[] {
				});
				this.listOwn.updateUI();
			}
			return;
		}

		if (CUSTOM_COMMAND.equals(command)) {
			return;
		}
	}

}
