package net.sachau.murpg.gui.attribute;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.text.*;

import net.sachau.murpg.data.attribute.Attribute;
import net.sachau.murpg.data.GeneralData;


public class AttributeNumberPanel extends JPanel implements ActionListener {

	Attribute attribute;
	int AN;
	JTextField actionName;
	JFormattedTextField actionNumber;
	JSpinner anSpinner;
	JTree list;
	private static String APPLY_COMMAND = "apply";
	private static String COST_COMMAND = "cost";

	boolean isModifier;
	boolean isChallenge;
	public AttributeNumberPanel(Attribute a, JTree l) {
		super();
		list = l;

		attribute = a;

		setBorder(BorderFactory.createTitledBorder("Attribute"));
		actionName = new JTextField(attribute.name, 30);

		anSpinner = new JSpinner(new SpinnerNumberModel(attribute.AN, 0, 99, 1));
		anSpinner.setValue(new Integer(attribute.AN));

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		JButton applyButton = new JButton("Apply");
		JButton costButton = new JButton("Custom");
		applyButton.setActionCommand(APPLY_COMMAND);
		applyButton.addActionListener(this);
		costButton.setActionCommand(COST_COMMAND);
		costButton.addActionListener(this);

		JLabel t1 = new JLabel("Name:");
		JLabel t2 = new JLabel("AN:");


		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 1;
		con.gridy = 0;
		con.gridwidth = 5;
		add(actionName, con);

		con.gridx = 0;
		con.gridy = 1;
		con.gridwidth = 1;
		add(t2, con);

		con.weightx = 100;
		con.weighty = 0;

		con.gridx = 1;
		con.gridy = 1;
		con.gridwidth = 2;
		add(anSpinner, con);

		con.weightx = 0;
		con.weighty = 0;

		con.gridx = 5;
		con.gridy = 1;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.EAST;
		add(applyButton, con);

		con.gridx = 4;
		con.gridy = 1;
		con.gridwidth = 1;
		/*con.anchor = GridBagConstraints.EAST;
		add(costButton, con);
		*/
	}

	public void actionPerformed(ActionEvent e) {

		this.attribute.name = this.actionName.getText();

		String command = e.getActionCommand();

		if (APPLY_COMMAND.equals(command)) {

			if (!this.isChallenge) {
				this.attribute.AN =
					((Integer) this.anSpinner.getValue()).intValue();
			} else {
				this.attribute.cost.w =
					((Integer) this.anSpinner.getValue()).intValue();
			}

			//this.action.AN=(int)Integer.parseInt(this.actionNumber.getText().trim());
			GeneralData.statusline.setText("xyz");
			GeneralData.statusline.update();
			this.list.updateUI();
		}

		if (COST_COMMAND.equals(command)) {
			if (this.attribute.isAttribute) { //this attribute
				
			}
		}

	}
	protected MaskFormatter createFormatter(String s) {
		MaskFormatter formatter = null;
		try {
			formatter = new MaskFormatter(s);
		} catch (java.text.ParseException exc) {
			System.err.println("formatter is bad: " + exc.getMessage());
			System.exit(-1);
		}
		return formatter;
	}

}
