package net.sachau.murpg.gui.bonus;
import javax.swing.*;

import net.sachau.murpg.data.bonus.Bonus;
import net.sachau.murpg.data.bonus.BonusList;
import net.sachau.murpg.data.cost.Cost;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class BonusPanel extends JPanel implements ActionListener {

	BonusList olist;
	BonusList alist;

	JTextField custName;
	JTextField custNameShort;
	JTextField custCostW;
	JTextField custCostR;
	JCheckBox custFlat;
	JList listOwn;
	JList listAvail;
	private static String ADD_COMMAND = "add";
	private static String REMOVE_COMMAND = "remove";
	private static String CUSTOM_COMMAND = "custom";

	public BonusPanel(BonusList ol, BonusList al) {
		super();

		setBorder(BorderFactory.createTitledBorder("Bonusses"));
		custName = new JTextField("", 5);
		custNameShort = new JTextField("", 5);
		JTextField custCostW = new JTextField("", 5);
		JTextField custCostR = new JTextField("", 5);
		JCheckBox custFlat = new JCheckBox();
		olist = ol;
		alist = al;
		listOwn = new JList(olist.toArray());
		listAvail = new JList(alist.toArray());
		listOwn.setVisibleRowCount(5);
		listAvail.setVisibleRowCount(5);
		listOwn.setFixedCellWidth(8 * 30);
		listAvail.setFixedCellWidth(8 * 30);
		JScrollPane listScroller = new JScrollPane(listOwn);
		JScrollPane listScroller1 = new JScrollPane(listAvail);

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		JButton addBonus = new JButton("Add");
		addBonus.setActionCommand(ADD_COMMAND);
		addBonus.addActionListener(this);

		JButton removeBonus = new JButton("Remove");
		removeBonus.setActionCommand(REMOVE_COMMAND);
		removeBonus.addActionListener(this);

		JButton customBonus = new JButton("Custom");
		customBonus.setActionCommand(CUSTOM_COMMAND);
		customBonus.addActionListener(this);

		JLabel t1 = new JLabel("Selected Bonuses");
		JLabel t2 = new JLabel("Available Bonuses");

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 4;
		con.gridy = 0;
		add(t2, con);

		con.gridx = 0;
		con.gridy = 1;
		con.gridheight = 3;
		con.gridwidth = 3;
		add(listScroller, con);

		con.gridx = 4;
		con.gridy = 1;
		con.gridheight = 3;
		con.gridwidth = 3;
		add(listScroller1, con);
		con.gridheight = 1;

		con.anchor = GridBagConstraints.EAST;
		con.gridx = 4;
		con.gridy = 4;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(customBonus, con);

		con.gridx = 5;
		con.gridy = 4;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(addBonus, con);

		con.gridx = 6;
		con.gridy = 4;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(removeBonus, con);

	}

	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		boolean hasChanged = false;

		if (ADD_COMMAND.equals(command)) {

			for (int i = 0;
				i < this.listAvail.getSelectedValues().length;
				i++) {

				Bonus o =
					(Bonus) ((Bonus) this.listAvail.getSelectedValues()[i])
						.clone();
				Cost cost = (Cost) o.cost.clone();
				o.cost=cost;						
				this.olist.addBonus(o);

				hasChanged = true;
			}

			if (hasChanged) {

				this.listOwn.setListData(this.olist.toArray());
				this.listAvail.setSelectedIndices(new int[] {
				});
				this.listOwn.setSelectedIndices(new int[] {
				});
				this.listOwn.updateUI();
			}
		}

		if (REMOVE_COMMAND.equals(command)) {
			for (int i = 0; i < this.listOwn.getSelectedValues().length; i++) {
				Bonus o = (Bonus) ((Bonus) this.listOwn.getSelectedValues()[i]);
				this.olist.removeBonus(o.key);
				hasChanged = true;
			}
			if (hasChanged) {
				this.listOwn.setListData(this.olist.toArray());
				this.listAvail.setSelectedIndices(new int[] {
				});
				this.listOwn.setSelectedIndices(new int[] {
				});
				this.listOwn.updateUI();
			}
			return;

		}

		if (CUSTOM_COMMAND.equals(command)) {
			Bonus o = new Bonus();
			
			for (int i = 0;
				i < this.listOwn.getSelectedValues().length;
				i++) {

				o = (Bonus) ((Bonus) this.listOwn.getSelectedValues()[i]);
				hasChanged = true;
			}
			if (hasChanged) {

				BonusCostFrame b = new BonusCostFrame(o, this.listOwn);
			}
			System.out.println("XXX "+hasChanged);
			return;

		}

	}

}
