package net.sachau.murpg.gui.challenge;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.text.*;

import net.sachau.murpg.data.action.ActionBase;
import net.sachau.murpg.data.modifier.Modifier;
import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.gui.character.*;


import java.text.DecimalFormat;

public class ChallengePanel extends JPanel implements ActionListener {

	ActionBase action;
	int AN;
	JTextField actionName;
	JFormattedTextField actionNumber;
	JSpinner anSpinner;
	JTree list;
	boolean isModifier;
	CharacterTree ctree;
	public ChallengePanel(CharacterTree t) {
		super();
		ctree = t;

		setBorder(BorderFactory.createLineBorder(Color.black, 1));

		actionName = new JTextField("", 30);
		anSpinner = new JSpinner(new SpinnerNumberModel(0, -99, 0, 1));

		anSpinner.setValue(new Integer(0));

		actionNumber = new JFormattedTextField(new DecimalFormat("##"));

		actionNumber.setValue(new Integer(0));
		actionNumber.setColumns(3);

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		JButton applyButton = new JButton("Add");
		applyButton.addActionListener(this);

		JLabel t1 = new JLabel("Name:");
		JLabel t2 = new JLabel("Cost(White):");

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 1;
		con.gridy = 0;
		con.gridwidth = 5;
		add(actionName, con);

		con.gridx = 0;
		con.gridy = 1;
		con.gridwidth = 1;
		add(t2, con);

		con.weightx = 100;
		con.weighty = 0;

		con.gridx = 1;
		con.gridy = 1;
		con.gridwidth = 2;
		add(anSpinner, con);

		con.weightx = 0;
		con.weighty = 0;

		con.gridx = 5;
		con.gridy = 1;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.EAST;
		add(applyButton, con);

	}

	public void actionPerformed(ActionEvent e) {
		if (this.actionName.getText().trim().length() > 0) {
			Character c =
				(Character) GeneralData.character.get(GeneralData.charindex);
			boolean hasChanged = false;

			Modifier m = new Modifier();
			int w = ((Integer) this.anSpinner.getValue()).intValue();
			m.name = this.actionName.getText();
			m.cost = new Cost(w, 0);
			m.AN = w;
			m.flat = 1;
			m.isChallenge = true;

			m.key = GeneralData.modifierCounter++;
			c.challenges.add((Modifier) m);
			this.ctree.addObject((Modifier) m);
			hasChanged = true;
		}

	}
	protected MaskFormatter createFormatter(String s) {
		MaskFormatter formatter = null;
		try {
			formatter = new MaskFormatter(s);
		} catch (java.text.ParseException exc) {
			System.err.println("formatter is bad: " + exc.getMessage());
			System.exit(-1);
		}
		return formatter;
	}

}
