package net.sachau.murpg.gui.character;
import javax.swing.*;

import net.sachau.murpg.data.character.Character;


import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;


public class CharacterClassPanel extends JPanel implements ActionListener {

	Character character;
	ButtonGroup group;
	JTree list;
	private static String RADIO_NORMAL = "Normal";
	private static String RADIO_PA = "Powered Armor";
	private static String RADIO_ROBOT = "Robot";

	public CharacterClassPanel(Character a) {
		super();
		
		character = a;

		setBorder(BorderFactory.createTitledBorder("Character Selection"));
		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		JRadioButton b1 = new JRadioButton(RADIO_NORMAL);
		b1.setActionCommand(RADIO_NORMAL);
		b1.addActionListener(this);

		JRadioButton b2 = new JRadioButton(RADIO_PA);
		b2.setActionCommand(RADIO_PA);
		b2.addActionListener(this);
		
		JRadioButton b3 = new JRadioButton(RADIO_ROBOT);
		b3.setActionCommand(RADIO_ROBOT);
		b3.addActionListener(this);

		if (!character.isPA && !character.isRobot) {
			b1.setSelected(true);
			b2.setSelected(false);
			b3.setSelected(false);			
		}
	
		if (character.isPA) {
			b1.setSelected(false);
			b2.setSelected(true);
			b3.setSelected(false);			
		}

		if (character.isRobot) {
			b1.setSelected(false);
			b2.setSelected(false);
			b3.setSelected(true);			
		}


		group = new ButtonGroup();
		
		group.add(b1);
		group.add(b2);
		group.add(b3);
		

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;
		
		con.gridx = 0;
		con.gridy = 0;
		add(b1, con);

		con.gridx = 0;
		con.gridy = 1;
		add(b2, con);

		con.gridx = 0;
		con.gridy = 2;
		add(b3, con);


	}

	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		
		
		if (RADIO_NORMAL.endsWith(command)) {
			this.character.isPA=false;
			this.character.isRobot=false;
		}
		if (RADIO_PA.endsWith(command)) {
			this.character.isPA=true;
			this.character.isRobot=false;
		}

		if (RADIO_ROBOT.endsWith(command)) {
			this.character.isPA=false;
			this.character.isRobot=true;
		}


	}

}
