package net.sachau.murpg.gui.character;

import javax.swing.*;

import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.data.character.Character;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.WindowListener;
import java.awt.event.WindowEvent;
import java.awt.event.ActionEvent;

public class CharacterPreviewFrame
	extends JFrame
	implements ActionListener, WindowListener {

	Character character;
	JPanel content;
	JTextArea editor;
	int charIndex;
	public CharacterPreviewFrame() {
		super("MURPG");
		content = new JPanel();

		character =
			(Character) GeneralData.character.get(GeneralData.charindex);

		addWindowListener(this);

		setLocation(
			GeneralData.mainframe.getX() + GeneralData.mainframe.getWidth() / 2,
			GeneralData.mainframe.getY()
				+ GeneralData.mainframe.getHeight() / 2);

		content.setBorder(BorderFactory.createTitledBorder("Preview"));

		//GeneralData.showAN=true;

		GridBagLayout layout = new GridBagLayout();
		content.setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		editor = new JTextArea();
		editor = new JTextArea(10, 40);
		editor.setText(character.toBasicHtml());
		editor.setCaretPosition(0);
		JScrollPane scrollingArea = new JScrollPane(editor);

		//editor.setFont(new Font("Sans-Serif", Font.PLAIN, 10));

		JButton update = new JButton("Update");
		update.addActionListener(this);

		con.gridx = 0;
		
		con.gridy = 0;
		con.weightx = 100;
		con.weighty = 100;
		con.gridwidth = 7;
		con.gridheight = 4;
		con.fill=GridBagConstraints.BOTH;
		con.anchor = GridBagConstraints.WEST;

		content.add(scrollingArea, con);
		con.gridx = 6;
		con.gridy = 5;
		con.weighty = 0;
		con.gridwidth = 0;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.EAST;
		
		content.add(update, con);

		setContentPane(content);
		setSize(300, 450);

		//GeneralData.mainframe.setEnabled(false);

	}

	public void showPreview() {
		Character c =
			(Character) GeneralData.character.get(GeneralData.charindex);
		this.editor.setText(c.toBasicHtml());
		this.editor.setCaretPosition(0);
		System.out.println(c.toBasicHtml());
		System.out.println(GeneralData.charindex);
		this.setContentPane(this.content);
		this.setSize(300, 450);

		this.setVisible(true);
	}

	public void hidePreview() {
		this.setVisible(false);
	}
	public void actionPerformed(ActionEvent e) {
		//GeneralData.mainframe.setEnabled(true);
		Character c =
			(Character) GeneralData.character.get(GeneralData.charindex);
		this.editor.setText(c.toBasicHtml());
		this.editor.setCaretPosition(0);
	}

	public void windowActivated(WindowEvent w) {
	}

	public void windowClosed(WindowEvent w) {
		//GeneralData.mainframe.setEnabled(true);
	}

	public void windowClosing(WindowEvent w) {
		GeneralData.mainframe.setEnabled(true);
	}

	public void windowDeactivated(WindowEvent w) {
	}

	public void windowDeiconified(WindowEvent w) {
	}

	public void windowIconified(WindowEvent w) {
	}

	public void windowOpened(WindowEvent w) {

	}

}
