package net.sachau.murpg.gui.equipment;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.text.*;

import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.data.equipment.Equipment;


public class EquipmentNumberPanel extends JPanel implements ActionListener {

	Equipment equ;
	int AN;
	JTextField equipmentName;
	JFormattedTextField actionNumber;
	JSpinner wSpinner, rSpinner, dSpinner;
	JLabel t2, temp;
	boolean showAN;
	JTree list;
	GridBagConstraints con;
	private static String APPLY_COMMAND = "apply";
	private static String COST_COMMAND = "cost";

	public EquipmentNumberPanel(Equipment a, JTree l) {
		super();
		list = l;
		showAN = false;
		equ = a;

		setBorder(BorderFactory.createTitledBorder("Modifier"));

		equipmentName = new JTextField(equ.name, 30);
		wSpinner = new JSpinner(new SpinnerNumberModel(equ.cost.w, 0, 99, 1));

		rSpinner = new JSpinner(new SpinnerNumberModel(equ.cost.r, 0, 99, 1));

		dSpinner =
			new JSpinner(new SpinnerNumberModel(equ.costDollar, 0.0, 999999999.99, 0.1));

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		con = new GridBagConstraints();

		JButton applyButton = new JButton("Apply");
		JButton costButton = new JButton("Custom");
		applyButton.setActionCommand(APPLY_COMMAND);
		applyButton.addActionListener(this);
		costButton.setActionCommand(COST_COMMAND);
		costButton.addActionListener(this);

		JLabel t1 = new JLabel("Name:");
		t2 = new JLabel("W/R/$:");
		temp = new JLabel("    ");

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 0;
		con.gridy = 1;
		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		add(t2, con);

		con.gridx = 1;
		con.gridy = 0;
		con.gridwidth = 5;
		add(equipmentName, con);

		con.weighty = 0;
		con.weightx = 0;
		con.gridx = 1;
		con.gridy = 1;
		con.gridwidth = 1;

		add(wSpinner, con);

		con.gridx = 2;
		con.gridy = 1;
		con.gridwidth = 1;
		con.weighty = 0;
		con.weightx = 0;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.WEST;
		add(rSpinner, con);

		con.gridx = 3;
		con.gridy = 1;
		con.weighty = 0;
		con.weightx = 0;
		con.gridwidth = 2;
		con.anchor = GridBagConstraints.WEST;
		add(dSpinner, con);

		con.weightx = 0;
		con.weighty = 0;
		con.gridx = 5;
		con.gridy = 1;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.EAST;
		add(applyButton, con);

	}
	public void updateView() {
		this.con.anchor = GridBagConstraints.WEST;
		this.con.weightx = 100;

		this.con.weighty = 0;
		this.con.gridx = 1;
		this.con.gridy = 1;
		this.con.gridwidth = 2;

		/*if (this.modifier.flat == 0) {
			if (!this.showAN) {
				this.add(this.anSpinner, this.con);
				this.con.weightx = 0;
				con.gridx = 0;
				con.gridy = 1;
				con.gridwidth = 1;
				this.add(this.t2, this.con);
				this.showAN = true;
			}
		} else {
			if (this.showAN) {
				this.remove(this.anSpinner);
				this.remove(this.t2);
				this.showAN = false;
		
				this.add(this.temp, con);
			} else {
				this.add(this.anSpinner, this.con);
				this.con.weightx = 0;
				con.gridx = 0;
				con.gridy = 1;
				con.gridwidth = 1;
				this.add(this.t2, this.con);
				this.showAN = true;
			}
		
		}
		*/
		this.updateUI();
	}

	public void actionPerformed(ActionEvent e) {

		this.equ.name = this.equipmentName.getText();

		String command = e.getActionCommand();

		if (APPLY_COMMAND.equals(command)) {

			this.equ.cost.w = ((Integer) this.wSpinner.getValue()).intValue();

			this.equ.cost.r = ((Integer) this.rSpinner.getValue()).intValue();
		}

		//this.action.AN=(int)Integer.parseInt(this.actionNumber.getText().trim());

		GeneralData.statusline.update();
		this.list.updateUI();

	}
	protected MaskFormatter createFormatter(String s) {
		MaskFormatter formatter = null;
		try {
			formatter = new MaskFormatter(s);
		} catch (java.text.ParseException exc) {
			System.err.println("formatter is bad: " + exc.getMessage());
			System.exit(-1);
		}
		return formatter;
	}

}
