package net.sachau.murpg.gui.equipment;
import javax.swing.*;

import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.cost.*;
import net.sachau.murpg.data.equipment.Equipment;
import net.sachau.murpg.data.equipment.EquipmentList;
import net.sachau.murpg.data.*;
import net.sachau.murpg.gui.character.*;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;

public class EquipmentPanel extends JPanel implements ActionListener {

	EquipmentList equipmentlist;
	EquipmentList ownlist;
	CharacterTree ctree;
	JTextField custName;
	JTextField custNameShort;
	JTextField custCostW;
	JTextField custCostR;
	JCheckBox custFlat;
	boolean isChallenge;
	JList listAvail;
	JList listOwn;
	public EquipmentPanel(CharacterTree t) {
		super();
		ctree = t;

		ownlist =
			(EquipmentList)
				(
					(Character) GeneralData.character.get(
						GeneralData.charindex)).equipment;
		equipmentlist = (EquipmentList) GeneralData.equipment;

		setBorder(BorderFactory.createTitledBorder("Equipment"));

		custName = new JTextField("", 5);
		custNameShort = new JTextField("", 5);
		JTextField custCostW = new JTextField("", 5);
		JTextField custCostR = new JTextField("", 5);
		JCheckBox custFlat = new JCheckBox();
		//GeneralData.showAN=false;
		listAvail = new JList(equipmentlist.toArray());
		listOwn = new JList(ownlist.toArray());
		listAvail.setCellRenderer(new MyCellRenderer());

		//GeneralData.showAN=true;
		listAvail.setVisibleRowCount(15);

		listAvail.setFixedCellWidth(8 * 50);

		JScrollPane listScroller1 = new JScrollPane(listAvail);

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		//OptionPanelRemoveOption removeOption=new BonusPanelRemoveBonus(olist,listOwn,listAvail);
		//OptionPanelCustomOption customOption=new BonusPanelCustomBonus(olist, listOwn,custName,
		//custNameShort,custCostW,custCostR,custFlat);
		JButton addButton = new JButton("Add");
		addButton.addActionListener(this);

		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;

		con.gridx = 0;
		con.gridy = 0;
		con.gridwidth = 1;
		con.gridheight = 15;
		add(listScroller1, con);

		con.gridx = 0;
		con.gridy = 15;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.EAST;
		add(addButton, con);

	}

	public void actionPerformed(ActionEvent e) {

		boolean hasChanged = false;

		for (int i = 0; i < this.listAvail.getSelectedValues().length; i++) {
			Equipment a =
				(Equipment) ((Equipment) this.listAvail.getSelectedValues()[i])
					.clone();

			Cost c = (Cost) a.cost.clone();

			a.cost = c;

			//a.isChallenge=this.isChallenge;
			this.ownlist.add(a);

			this.ctree.addObject((Equipment) a);
			hasChanged = true;
		}

		if (hasChanged) {
			this.listAvail.setSelectedIndices(new int[] {
			});
			this.listOwn.updateUI();
		}

	}

	class MyCellRenderer extends JLabel implements ListCellRenderer {

		// This is the only method defined by ListCellRenderer.
		// We just reconfigure the JLabel each time we're called.

		public Component getListCellRendererComponent(JList list, Object value,
		// value to display
		int index, // cell index
		boolean isSelected, // is the cell selected
		boolean cellHasFocus) // the list and the cell have the focus
		{
			Equipment a = (Equipment) value;
			String s = a.toString();
			setText(s);

			if (isSelected) {
				setBackground(list.getSelectionBackground());
				setForeground(list.getSelectionForeground());
			} else {
				setBackground(list.getBackground());
				setForeground(list.getForeground());
			}
			setEnabled(list.isEnabled());
			setFont(list.getFont());
			setOpaque(true);
			return this;
		}
	}

}
