package net.sachau.murpg.gui.modifier;
import javax.swing.*;
import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.text.*;

import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.data.modifier.Modifier;



public class ModifierNumberPanel extends JPanel implements ActionListener {

	Modifier modifier;
	int AN;
	JTextField actionName;
	JFormattedTextField actionNumber;
	JSpinner anSpinner;
	JLabel t2, temp;
	boolean showAN;
	JTree list;
	GridBagConstraints con;
	private static String APPLY_COMMAND = "apply";
	private static String COST_COMMAND = "cost";

	public ModifierNumberPanel(Modifier a, JTree l) {
		super();
		list = l;
		showAN = false;
		modifier = a;

		setBorder(BorderFactory.createTitledBorder("Modifier"));

		actionName = new JTextField(modifier.name, 30);
		if (!a.isChallenge) {
			anSpinner =
				new JSpinner(new SpinnerNumberModel(modifier.AN, 0, 99, 1));
		} else {
			anSpinner =
				new JSpinner(new SpinnerNumberModel(modifier.cost.w, 0, 99, 1));
		}
		if (!a.isChallenge) {
			anSpinner.setValue(new Integer(modifier.AN));
		} else {
			anSpinner.setValue(new Integer(modifier.cost.w));
		}

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		con = new GridBagConstraints();

		JButton applyButton = new JButton("Apply");
		JButton costButton = new JButton("Custom");
		applyButton.setActionCommand(APPLY_COMMAND);
		applyButton.addActionListener(this);
		costButton.setActionCommand(COST_COMMAND);
		costButton.addActionListener(this);

		JLabel t1 = new JLabel("Name:");
		t2 = new JLabel("MN:");
		temp = new JLabel("    ");
		if (modifier.isChallenge) {
			t2.setText("Cost(w):");
		}

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 1;
		con.gridy = 0;
		con.gridwidth = 5;
		add(actionName, con);

		con.gridx = 0;
		con.gridy = 1;
		con.gridwidth = 1;
		if (modifier.flat == 0) {
			showAN = true;
			add(t2, con);
		}

		con.weighty = 0;
		con.weightx = 100;
		con.gridx = 1;
		con.gridy = 1;
		con.gridwidth = 2;
		if (modifier.flat == 0) {
			add(anSpinner, con);
		} else {
			add(temp, con);
		}

		con.weightx = 0;
		con.weighty = 0;

		if (!modifier.isChallenge) {

			con.gridx = 4;
			con.gridy = 1;
			con.gridwidth = 1;
			con.anchor = GridBagConstraints.EAST;
			add(costButton, con);
		}
		con.gridx = 5;
		con.gridy = 1;
		con.gridwidth = 1;
		con.anchor = GridBagConstraints.EAST;
		add(applyButton, con);

	}
	public void updateView() {
		this.con.anchor = GridBagConstraints.WEST;
		this.con.weightx = 100;

		this.con.weighty = 0;
		this.con.gridx = 1;
		this.con.gridy = 1;
		this.con.gridwidth = 2;

		if (this.modifier.flat == 0) {
			if (!this.showAN) {
				this.add(this.anSpinner, this.con);
				this.con.weightx = 0;
				con.gridx = 0;
				con.gridy = 1;
				con.gridwidth = 1;
				this.add(this.t2, this.con);
				this.showAN = true;
			}
		} else {
			if (this.showAN) {
				this.remove(this.anSpinner);
				this.remove(this.t2);
				this.showAN = false;

				this.add(this.temp, con);
			} else {
				this.add(this.anSpinner, this.con);
				this.con.weightx = 0;
				con.gridx = 0;
				con.gridy = 1;
				con.gridwidth = 1;
				this.add(this.t2, this.con);
				this.showAN = true;
			}

		}
		this.updateUI();
	}

	public void actionPerformed(ActionEvent e) {

		this.modifier.name = this.actionName.getText();

		String command = e.getActionCommand();

		if (APPLY_COMMAND.equals(command)) {

			if (!this.modifier.isChallenge) {
				this.modifier.AN =
					((Integer) this.anSpinner.getValue()).intValue();
			} else {

				this.modifier.cost.w =
					((Integer) this.anSpinner.getValue()).intValue();
			}

			//this.action.AN=(int)Integer.parseInt(this.actionNumber.getText().trim());
			GeneralData.statusline.setText("xyz");
			GeneralData.statusline.update();
			this.list.updateUI();
		}

		if (COST_COMMAND.equals(command)) {
			/*	if (this.action.isAttribute) { //this attribute
					CostFrameAction c = new CostFrameAction(this.action);
				}
			*/
			ModifierCostFrame c = new ModifierCostFrame(this.modifier, this);
		}

	}
	protected MaskFormatter createFormatter(String s) {
		MaskFormatter formatter = null;
		try {
			formatter = new MaskFormatter(s);
		} catch (java.text.ParseException exc) {
			System.err.println("formatter is bad: " + exc.getMessage());
			System.exit(-1);
		}
		return formatter;
	}

}
