package net.sachau.murpg.gui.modifier;
import javax.swing.*;


import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.gui.character.*;
import net.sachau.murpg.data.modifier.Modifier;
import net.sachau.murpg.data.modifier.ModifierList;
import net.sachau.murpg.data.option.OptionList;

import java.awt.*;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;



public class ModifierPanel extends JPanel implements ActionListener{

	ModifierList modifierlist;
	ModifierList ownlist;
	CharacterTree ctree;
	JTextField custName;
	JTextField custNameShort;
	JTextField custCostW;
	JTextField custCostR;
	JCheckBox custFlat;
	boolean isChallenge; 
	JList listAvail;
	JList listOwn;
	public ModifierPanel(CharacterTree t,boolean isC) {
		super();
		ctree=t;
		isChallenge=isC;
		
		if (!isC) {
			modifierlist=(ModifierList)GeneralData.modifiers;
			ownlist=(ModifierList)((Character)GeneralData.character.get(GeneralData.charindex)).modifiers;
		} else {
			
			ownlist=(ModifierList)((Character)GeneralData.character.get(GeneralData.charindex)).challenges;
			modifierlist=(ModifierList)GeneralData.challenges;
		}
		
		
		if (!isC) {
			setBorder(BorderFactory.createTitledBorder("Modifiers"));
		} else {
			setBorder(BorderFactory.createTitledBorder("Challenges"));
		}
		
		custName = new JTextField("", 5);
		custNameShort = new JTextField("", 5);
		JTextField custCostW = new JTextField("", 5);
		JTextField custCostR = new JTextField("", 5);
		JCheckBox custFlat = new JCheckBox();
		//GeneralData.showAN=false;
		listAvail=new JList(modifierlist.toArray());
		listOwn=new JList(ownlist.toArray());
		listAvail.setCellRenderer(new MyCellRenderer());
		
		//GeneralData.showAN=true;
		listAvail.setVisibleRowCount(15);
	
		listAvail.setFixedCellWidth(8*50);
		
		JScrollPane listScroller1 = new JScrollPane(listAvail);
		
		
		
			
		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();
		

		//OptionPanelRemoveOption removeOption=new BonusPanelRemoveBonus(olist,listOwn,listAvail);
		//OptionPanelCustomOption customOption=new BonusPanelCustomBonus(olist, listOwn,custName,
		//custNameShort,custCostW,custCostR,custFlat);
		JButton addButton= new JButton("Add");
		addButton.addActionListener(this);

		
		

		con.gridwidth=1;
		con.gridheight=1;			
		con.anchor=GridBagConstraints.WEST;
		
		con.gridx=0;
		con.gridy=0;
		

		con.gridx=0;
		con.gridy=0;
		con.gridwidth=1;
		con.gridheight=15;			
		add(listScroller1,con);

		con.gridx=0;
		con.gridy=15;
		con.gridwidth=1;
		con.gridheight=1;			
		con.anchor=GridBagConstraints.EAST;
		add(addButton,con);


	}

	public void actionPerformed (ActionEvent e) {
		

						 

		boolean hasChanged=false;
		
		

		for (int i=0;i<this.listAvail.getSelectedValues().length;i++) {
			Modifier a
			=(Modifier)((Modifier)this.listAvail.getSelectedValues()[i]).clone();
			
			OptionList o=(OptionList)a.option.clone();
			Cost c=(Cost)a.cost.clone();
			Cost pa_c=(Cost)a.pa_cost.clone();
			o.clear();
			a.option=o;
			a.cost=c;
			a.pa_cost=pa_c;
			//a.isChallenge=this.isChallenge;
			this.ownlist.add(a);
			
			this.ctree.addObject((Modifier)a);
			hasChanged=true;			
		}

		if (hasChanged) {
			this.listAvail.setSelectedIndices(new int[]{});
			this.listOwn.updateUI();
		}


	}


	class MyCellRenderer extends JLabel implements ListCellRenderer {

		// This is the only method defined by ListCellRenderer.
		// We just reconfigure the JLabel each time we're called.

		public Component getListCellRendererComponent(
		  JList list,
		  Object value,            // value to display
		  int index,               // cell index
		  boolean isSelected,      // is the cell selected
		  boolean cellHasFocus)    // the list and the cell have the focus
		{
			Modifier a=(Modifier)value;
			String s = a.toString1();
			setText(s);
			
		  if (isSelected) {
				setBackground(list.getSelectionBackground());
			  setForeground(list.getSelectionForeground());
		  }
			else {
			  setBackground(list.getBackground());
			  setForeground(list.getForeground());
		  }
		  setEnabled(list.isEnabled());
		  setFont(list.getFont());
			setOpaque(true);
			return this;
		}
	}


}
