package net.sachau.murpg.gui.option;
import javax.swing.*;

import net.sachau.murpg.data.character.Character;
import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.option.Option;
import net.sachau.murpg.data.option.OptionList;
import net.sachau.murpg.data.GeneralData;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class OptionPanel extends JPanel implements ActionListener {

	OptionList olist;
	OptionList alist;

	JTextField custName;
	JTextField custNameShort;
	JTextField custCostW;
	JTextField custCostR;
	JCheckBox custFlat;
	JList listOwn;
	JList listAvail;
	private static String ADD_COMMAND = "add";
	private static String REMOVE_COMMAND = "remove";
	private static String CUSTOM_COMMAND = "custom";
	public OptionPanel(OptionList ol, OptionList al, boolean showCustom,boolean usePA) {
		super();
		String t="Options";
		if (usePA) {
			t="PA Options";
		}
		
		setBorder(BorderFactory.createTitledBorder(t));
		custName = new JTextField("", 5);
		custNameShort = new JTextField("", 5);
		JTextField custCostW = new JTextField("", 5);
		JTextField custCostR = new JTextField("", 5);
		JCheckBox custFlat = new JCheckBox();
		olist = ol;
		alist = al;
		listOwn = new JList(olist.toArray());
		listAvail = new JList(alist.toArray());
		listOwn.setVisibleRowCount(5);
		listAvail.setVisibleRowCount(5);
		listOwn.setFixedCellWidth(8 * 30);
		listAvail.setFixedCellWidth(8 * 30);
		JScrollPane listScroller = new JScrollPane(listOwn);
		JScrollPane listScroller1 = new JScrollPane(listAvail);

		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		GridBagConstraints con = new GridBagConstraints();

		/*		OptionPanelAddOption addOption=new OptionPanelAddOption(olist,listOwn,listAvail);
				OptionPanelRemoveOption removeOption=new OptionPanelRemoveOption(olist,listOwn,listAvail);
				OptionPanelCustomOption customOption=new OptionPanelCustomOption(olist, listOwn,custName,
				custNameShort,custCostW,custCostR,custFlat);
		*/
		JButton addOption = new JButton("Add");
		addOption.setActionCommand(ADD_COMMAND);
		addOption.addActionListener(this);

		JButton removeOption = new JButton("Remove");
		removeOption.setActionCommand(REMOVE_COMMAND);
		removeOption.addActionListener(this);

		JButton customOption = new JButton("Custom");
		customOption.setActionCommand(CUSTOM_COMMAND);
		customOption.addActionListener(this);

		JLabel t1 = new JLabel("Selected Options");
		JLabel t2 = new JLabel("Available Options");

		con.weightx = 0;
		con.weighty = 0;
		con.gridwidth = 1;
		con.gridheight = 1;
		con.anchor = GridBagConstraints.WEST;

		con.gridx = 0;
		con.gridy = 0;
		add(t1, con);

		con.gridx = 4;
		con.gridy = 0;
		add(t2, con);

		/*		con.gridx=0;
				con.gridy=1;
				add(addOption,con);
		
				con.gridx=0;
				con.gridy=2;
				add(removeOption,con);
		*/

		con.gridx = 0;
		con.gridy = 1;
		con.gridheight = 3;
		con.gridwidth = 3;
		add(listScroller, con);

		con.gridx = 4;
		con.gridy = 1;
		con.gridheight = 3;
		con.gridwidth = 3;
		add(listScroller1, con);

		con.anchor = GridBagConstraints.EAST;
		if (showCustom) {

			con.gridx = 4;
			con.gridy = 4;
			con.gridheight = 1;
			con.gridwidth = 1;
			add(customOption, con);
		}
		con.gridx = 5;
		con.gridy = 4;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(addOption, con);

		con.gridx = 6;
		con.gridy = 4;
		con.gridheight = 1;
		con.gridwidth = 1;
		add(removeOption, con);

	}

	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		boolean hasChanged = false;

		Character c =
			(Character) GeneralData.character.get(GeneralData.charindex);

		if (ADD_COMMAND.equals(command)) {
			for (int i = 0;
				i < this.listAvail.getSelectedValues().length;
				i++) {
				Option o =
					(Option) ((Option) this.listAvail.getSelectedValues()[i])
						.clone();
						
				
				Cost cost = (Cost) o.cost.clone();
				Cost pa_cost = (Cost) o.pa_cost.clone();
				o.cost = cost;
				o.pa_cost = pa_cost;
				
				this.olist.addOption(o);
				hasChanged = true;
			}

			if (hasChanged) {
				this.listOwn.setListData(this.olist.toArray());
				this.listAvail.setSelectedIndices(new int[] {
				});
				this.listOwn.setSelectedIndices(new int[] {
				});
				this.listOwn.updateUI();
			}
			return;
		}
		if (REMOVE_COMMAND.equals(command)) {

			for (int i = 0; i < this.listOwn.getSelectedValues().length; i++) {
				Option o =
					(Option) ((Option) this.listOwn.getSelectedValues()[i]);
				this.olist.removeOption(o.key);
				hasChanged = true;
			}
			if (hasChanged) {
				this.listOwn.setListData(this.olist.toArray());
				this.listAvail.setSelectedIndices(new int[] {
				});
				this.listOwn.setSelectedIndices(new int[] {
				});
				this.listOwn.updateUI();
			}
			return;
		}

		if (CUSTOM_COMMAND.equals(command)) {

			for (int i = 0; i < this.listOwn.getSelectedValues().length; i++) {
				Option o =
					(Option) ((Option) this.listOwn.getSelectedValues()[i]);
				o.dump();
				OptionCostFrame f = new OptionCostFrame(o,this.listOwn);
				return;
			}

		}
	}

}
