package net.sachau.murpg.xml;

import net.sachau.murpg.data.attribute.Attribute;
import net.sachau.murpg.data.attribute.AttributeList;
import net.sachau.murpg.data.option.Option;
import net.sachau.murpg.data.option.OptionList;
import net.sachau.murpg.data.GeneralData;

import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXException;


import java.io.IOException;

public class AttributeParser extends DefaultHandler {
	public AttributeList attributelist;
	Attribute attribute;
	Option option;
	OptionList options;
	int keycounter;

	// Constructor
	public AttributeParser(String xmlFile) {

		attribute = new Attribute();
		attributelist = new AttributeList();
		options = new OptionList();
		option = new Option();
		keycounter = 0;

		//  Create a Xerces DOM Parser
		SAXParser parser = new SAXParser();

		//  Set Content Handler
		parser.setContentHandler(this);

		//  Parse the Document      
		try {
			parser.parse(xmlFile);
		} catch (SAXException e) {
			System.err.println(e);
		} catch (IOException e) {
			System.err.println(e);
		}
	}

	//  Start Element Event Handler
	public void startElement(
		String uri,
		String local,
		String qName,
		Attributes atts) {
		if (qName.equals("attribute")) {
			options = new OptionList();
			int cW = 0;
			int cR = 0;
			int cM = 1;

			if (atts != null) {
				for (int i = 0; i < atts.getLength(); i++) {
					if (atts.getQName(i).equals("name")) {
						attribute.name = atts.getValue(i);
					}
					if (atts.getQName(i).equals("short")) {
						attribute.shortName = atts.getValue(i);
					}

					if (atts.getQName(i).equals("cost")) {
						cW = (int) Integer.parseInt(atts.getValue(i));
					}
					if (atts.getQName(i).equals("multiply")) {
						cM = (int) Integer.parseInt(atts.getValue(i));
					}
					if (atts.getQName(i).equals("var")) {
						attribute.var = atts.getValue(i);
					}

				}
			}

			attribute.multi = cM;

		}
		if (qName.equals("option")) {
			int cW = 0;
			int cR = 0;
			int flat = 0;
			double cMulti = 1;
			option = new Option();
			if (atts != null) {
				for (int i = 0; i < atts.getLength(); i++) {
					if (atts.getQName(i).equals("name")) {
						option.name = atts.getValue(i);
					}
					if (atts.getQName(i).equals("short")) {
						option.shortName = atts.getValue(i);
					}
					if (atts.getQName(i).equals("cost")) {
						cW = (int) Integer.parseInt(atts.getValue(i));
					}
					if (atts.getQName(i).equals("cost_r")) {
						cR = (int) Integer.parseInt(atts.getValue(i));
					}

					if (atts.getQName(i).equals("flat")) {
						flat = (int) Integer.parseInt(atts.getValue(i));
					}

					if (atts.getQName(i).equals("multiply")) {
						cMulti = (double) Double.parseDouble(atts.getValue(i));
					}

				}
				option.cost.w = cW;
				option.cost.r = cR;
				option.flat = flat;
				option.multi = cMulti;
			}

		}

	}
	public void endElement(
		String namespaceURI,
		String localName,
		String qName) {

		if (qName.equals("attribute")) {
			attribute.option = options;
			attribute.key = this.keycounter;
			attribute.isAttribute = true;
			attributelist.addAttribute(attribute);
			attribute = new Attribute();
			options = new OptionList();
			this.keycounter++;
		}
		if (qName.equals("option")) {

			option.key = GeneralData.optionCounter++;
			options.addOption(option);
		}

	}

}