package net.sachau.murpg.xml;

import net.sachau.murpg.data.bonus.Bonus;
import net.sachau.murpg.data.bonus.BonusList;
import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.GeneralData;

import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
import org.xml.sax.SAXException;


import java.io.IOException;

public class BonusParser extends DefaultHandler {
	public BonusList bonuses;
	public Bonus bonus;
	
	
	// Constructor
	public BonusParser (String xmlFile) {
		bonuses=new BonusList();
		bonus=new Bonus();

		
		//  Create a Xerces DOM Parser
		SAXParser parser = new SAXParser();
        
		//  Set Content Handler
		parser.setContentHandler (this);

		//  Parse the Document      
		try {
			parser.parse(xmlFile);
		} catch (SAXException e) {
			System.err.println (e);
		} catch (IOException e) {
			System.err.println (e);
		}
	}
    
	//  Start Element Event Handler
	public void startElement (String uri, String local,
		String qName, Attributes atts)  {
					
		if (qName.equals("bonus")) {
			int cW=0;
			int cR=0;
			int cFlat=0;
			int cReadonly=0;
			bonus=new Bonus();
			if (atts!=null) {
				for (int i=0;i<atts.getLength();i++) {
					if (atts.getQName(i).equals("name")) {
						bonus.name=atts.getValue(i);
					}
					if (atts.getQName(i).equals("short")) {
						bonus.shortName=atts.getValue(i);
					}
					if (atts.getQName(i).equals("cost")) {
						cW=(int)Integer.parseInt(atts.getValue(i));				
					}					
					if (atts.getQName(i).equals("cost_r")) {
						cR=(int)Integer.parseInt(atts.getValue(i));				
					}					

					if (atts.getQName(i).equals("flat")) {
						cFlat=(int)Integer.parseInt(atts.getValue(i));				
					}					

					if (atts.getQName(i).equals("free")) {
						cReadonly=(int)Integer.parseInt(atts.getValue(i));				
					}					


				}
			}
			
			bonus.cost=new Cost(cW,cR);
			bonus.flat=cFlat;
			bonus.readonly=cReadonly;

		}


		
	}
	public void endElement(String namespaceURI, String localName, String qName) {     

		if (qName.equals("bonus")) {
			
			bonus.key=GeneralData.optionCounter++;
			this.bonuses.addBonus(bonus);
		}

	}	
	
}