package net.sachau.murpg.xml;

import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.GeneralData;
import net.sachau.murpg.data.modifier.Modifier;
import net.sachau.murpg.data.modifier.ModifierList;
import net.sachau.murpg.data.option.Option;
import net.sachau.murpg.data.option.OptionList;

import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
//import org.xml.sax.SAXParseException;
import org.xml.sax.SAXException;


import java.io.IOException;

//	A Simple SAX Application
//	Extends org.xml.sax.helpers.DefaultHandler
public class ModifierParser extends DefaultHandler {
	public ModifierList modlist;
	public Modifier mod;
	public Option option;
	
	public OptionList options;
	public boolean isChallenge;
	
	// Constructor
	public ModifierParser (String xmlFile,boolean isC) {
		modlist=new ModifierList();
		options=new OptionList();
		mod=new Modifier();
		option=new Option();
		isChallenge=isC;
		
		//  Create a Xerces DOM Parser
		SAXParser parser = new SAXParser();
        
		//  Set Content Handler
		parser.setContentHandler (this);

		//  Parse the Document      
		try {
			parser.parse(xmlFile);
		} catch (SAXException e) {
			System.err.println (e);
		} catch (IOException e) {
			System.err.println (e);
		}
	}
    
	//  Start Element Event Handler
	public void startElement (String uri, String local,
		String qName, Attributes atts)  {
					
		if (qName.equals("modifier")) {
			options=new OptionList();
			
			int cW=0;
			int cR=0;
			int cFlat=0;
			double cMulti=0;
			int cnoAn=0;
			this.mod.isChallenge=this.isChallenge;
			
			if (atts!=null) {
				for (int i=0;i<atts.getLength();i++) {
					if (atts.getQName(i).equals("name")) {
						mod.name=atts.getValue(i);
					}
					if (atts.getQName(i).equals("short")) {
						mod.shortName=atts.getValue(i);
					}

					if (atts.getQName(i).equals("cost")) {
						cW=(int)Integer.parseInt(atts.getValue(i));				
					}

					if (atts.getQName(i).equals("cost_r")) {
						cR=(int)Integer.parseInt(atts.getValue(i));				
					}

					if (atts.getQName(i).equals("flat")) {
						cFlat=(int)Integer.parseInt(atts.getValue(i));										
					}

					if (atts.getQName(i).equals("multi")) {
						cMulti=(double)Double.parseDouble(atts.getValue(i));
																
					}

					if (atts.getQName(i).equals("multiply_cost_by_mn")) {
						mod.multiplyByMn=(int)Integer.parseInt(atts.getValue(i));				
					}					
					
					
					
				}
			}			
			
			mod.flat=cFlat;
			mod.cost=new Cost(cW,cR);
			mod.multi=cMulti;
			mod.noAN=cnoAn;
			
		}
		if (qName.equals("option")) {
			int cW=0;
			int cR=0;
			int cFlat=0;
			option=new Option();
			if (atts!=null) {
				for (int i=0;i<atts.getLength();i++) {
					if (atts.getQName(i).equals("name")) {
						option.name=atts.getValue(i);
					}
					if (atts.getQName(i).equals("short")) {
						option.shortName=atts.getValue(i);
					}
					if (atts.getQName(i).equals("cost")) {
						cW=(int)Integer.parseInt(atts.getValue(i));				
					}					
					if (atts.getQName(i).equals("cost_r")) {
						cR=(int)Integer.parseInt(atts.getValue(i));				
					}					

					if (atts.getQName(i).equals("flat")) {
						cFlat=(int)Integer.parseInt(atts.getValue(i));				
					}					


				}
			}
			
			option.cost=new Cost(cW,cR);
			
			option.flat=cFlat;

		}
		
	}
	public void endElement(String namespaceURI, String localName, String qName) {     

		if (qName.equals("modifier")) {
			mod.option=options;
			mod.key=GeneralData.modifierCounter++;
			modlist.add((Modifier)mod);
			mod=new Modifier();
			options=new OptionList();
						
		}
		if (qName.equals("option")) {
			
			
			option.key=GeneralData.optionCounter++;
			options.addOption(option);
		}
		
	}	
	
}