package net.sachau.murpg.xml;

import net.sachau.murpg.data.cost.Cost;
import net.sachau.murpg.data.option.Option;
import net.sachau.murpg.data.option.OptionList;
import net.sachau.murpg.data.GeneralData;

import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.Attributes;
import org.xml.sax.helpers.DefaultHandler;
//import org.xml.sax.SAXParseException;
import org.xml.sax.SAXException;


import java.io.IOException;

//	A Simple SAX Application
//	Extends org.xml.sax.helpers.DefaultHandler
public class OptionParser extends DefaultHandler {
	public OptionList options;
	public Option option;

	// Constructor
	public OptionParser(String xmlFile) {
		options = new OptionList();
		option = new Option();

		//  Create a Xerces DOM Parser
		SAXParser parser = new SAXParser();

		//  Set Content Handler
		parser.setContentHandler(this);

		//  Parse the Document      
		try {
			parser.parse(xmlFile);
		} catch (SAXException e) {
			System.err.println(e);
		} catch (IOException e) {
			System.err.println(e);
		}
	}

	//  Start Element Event Handler
	public void startElement(
		String uri,
		String local,
		String qName,
		Attributes atts) {

		if (qName.equals("option")) {
			int cW = 0;
			int cR = 0;
			int cFlat = 0;
			int cActionOnly = 0;
			int cModifierOnly = 0;
			option = new Option();
			if (atts != null) {
				for (int i = 0; i < atts.getLength(); i++) {
					if (atts.getQName(i).equals("name")) {
						option.name = atts.getValue(i);
					}
					if (atts.getQName(i).equals("short")) {
						option.shortName = atts.getValue(i);
					}
					if (atts.getQName(i).equals("cost")) {
						cW = (int) Integer.parseInt(atts.getValue(i));
					}
					if (atts.getQName(i).equals("cost_r")) {
						cR = (int) Integer.parseInt(atts.getValue(i));
					}

					if (atts.getQName(i).equals("flat")) {
						cFlat = (int) Integer.parseInt(atts.getValue(i));
					}

					if (atts.getQName(i).equals("modifier_only")) {
						cModifierOnly =
							(int) Integer.parseInt(atts.getValue(i));
					}

					if (atts.getQName(i).equals("action_only")) {
						cModifierOnly =
							(int) Integer.parseInt(atts.getValue(i));
					}

				}
			}

			option.cost = new Cost(cW, cR);
			option.flat = cFlat;

		}

	}
	public void endElement(
		String namespaceURI,
		String localName,
		String qName) {

		if (qName.equals("option")) {

			option.key = GeneralData.optionCounter++;
			this.options.addOption(option);
		}

	}

}